#include "clip3d.h"
#include <math.h>

DWORD CPP_ZClipVisVrtx(DATA_VertexL *SrcV,
                       DATA_VertexL *DstV,
                       DATA__Camera *Camm,
                       DWORD              NumV
                      )
{
      DWORD RetL;
      DWORD NumZHit;
      DWORD CurV;
      FLOATINGPOINT DelX,DelY,DelZ;
      FLOATINGPOINT SaveX,SaveY,SaveZ;
      RetL=0;
      NumZHit=0;
      for (CurV=0;CurV<NumV;CurV++)
      {
          DelX=SrcV[CurV].EndX-SrcV[CurV].BegX;
          DelY=SrcV[CurV].EndY-SrcV[CurV].BegY;
          DelZ=SrcV[CurV].EndZ-SrcV[CurV].BegZ;
          if (DelZ==0)DelZ=1;
          if ((SrcV[CurV].BegZ<Camm[0].FocalDist)&&(SrcV[CurV].EndZ<Camm[0].FocalDist))
          {
          }else
          {  if (SrcV[CurV].BegZ<Camm[0].FocalDist)
             {
                DstV[RetL].BegZ=Camm[0].FocalDist;
                DstV[RetL].BegX=SrcV[CurV].BegX+
                                ((Camm[0].FocalDist-SrcV[CurV].BegZ)
                                *(DelX/DelZ));
                DstV[RetL].BegY=SrcV[CurV].BegY+
                                ((Camm[0].FocalDist-SrcV[CurV].BegZ)
                                *(DelY/DelZ));
                DstV[RetL].EndX=SrcV[CurV].EndX;
                DstV[RetL].EndY=SrcV[CurV].EndY;
                DstV[RetL].EndZ=SrcV[CurV].EndZ;
                RetL++;
                switch (NumZHit)
                {
                       case 0:SaveX=DstV[RetL-1].BegX;
                              SaveY=DstV[RetL-1].BegY;
                              SaveZ=DstV[RetL-1].BegZ;
                       break;
                       case 1:DstV[RetL].BegX=SaveX;
                              DstV[RetL].BegY=SaveY;
                              DstV[RetL].BegZ=SaveZ;
                              DstV[RetL].EndX=DstV[RetL-1].BegX;
                              DstV[RetL].EndY=DstV[RetL-1].BegY;
                              DstV[RetL].EndZ=DstV[RetL-1].BegZ;
                              RetL++;
                       break;
                       //default:
                }
                NumZHit++;
             }else if (SrcV[CurV].EndZ<Camm[0].FocalDist)
             {
                DstV[RetL].EndZ=Camm[0].FocalDist;
                DstV[RetL].EndX=SrcV[CurV].EndX+
                                ((Camm[0].FocalDist-SrcV[CurV].EndZ)
                                *(DelX/DelZ));
                DstV[RetL].EndY=SrcV[CurV].EndY+
                                ((Camm[0].FocalDist-SrcV[CurV].EndZ)
                                *(DelY/DelZ));
                DstV[RetL].BegX=SrcV[CurV].BegX;
                DstV[RetL].BegY=SrcV[CurV].BegY;
                DstV[RetL].BegZ=SrcV[CurV].BegZ;
                RetL++;
                switch (NumZHit)
                {
                       case 0:SaveX=DstV[RetL-1].EndX;
                              SaveY=DstV[RetL-1].EndY;
                              SaveZ=DstV[RetL-1].EndZ;
                       break;
                       case 1:DstV[RetL].BegX=SaveX;
                              DstV[RetL].BegY=SaveY;
                              DstV[RetL].BegZ=SaveZ;
                              DstV[RetL].EndX=DstV[RetL-1].EndX;
                              DstV[RetL].EndY=DstV[RetL-1].EndY;
                              DstV[RetL].EndZ=DstV[RetL-1].EndZ;
                              RetL++;
                       break;
                       //default:
                }
                NumZHit++;
             }else
             {
                DstV[RetL].BegX=SrcV[CurV].BegX;
                DstV[RetL].BegY=SrcV[CurV].BegY;
                DstV[RetL].BegZ=SrcV[CurV].BegZ;
                DstV[RetL].EndX=SrcV[CurV].EndX;
                DstV[RetL].EndY=SrcV[CurV].EndY;
                DstV[RetL].EndZ=SrcV[CurV].EndZ;
                RetL++;
             }
          }
      }
      return(RetL);
}

//eof