.386
.387
.MODEL FLAT,C
  public ASM_ScanConvertEdges
  _Ox                equ             00000h
  _Oy                equ             00008h
  _Oz                equ             00010h
  _Vx                equ             00018h
  _Vy                equ             00020h
  _Vz                equ             00028h
  _Ux                equ             00030h
  _Uy                equ             00038h
  _Uz                equ             00040h
  _Ui                equ             00048h
  _Uj                equ             00050h
  _Uc                equ             00058h
  _Vi                equ             00060h
  _Vj                equ             00068h
  _Vc                equ             00070h
  _Zi                equ             00078h
  _Zj                equ             00080h
  _Zc                equ             00088h
  _xx                equ             00090h
  _yy                equ             00098h
  _zz                equ             000A0h
  _u                 equ             000A8h
  _v                 equ             000B0h
  _z                 equ             000B8h
  _i                 equ             000C0h
  _j                 equ             000C8h ; preset
  _di                equ             000D0h
  _dj                equ             000D8h
  _zzz               equ             000E0h
  _u0                equ             000E8h
  _v0                equ             000ECh
  _ii                equ             000F0h ; set to zero before calling
  _jj                equ             000F4h ; set to zero before calling
  _Edges             equ             000F8h

  _PTR_Text              equ             00008h
  _PTR_Edge              equ             0000Ch
  _PTR_Data              equ             00010h
  _PTR_Hght              equ             00014h
  _PTR_BegY              equ             00018h
  _PTR_YAdd              equ             0001Ch
  _PTR_EndY              equ             00020h

  Empty_Edge             equ             0
  ; Edge table is (Height of poly)*( double + (2 * dword) )
  ; double is i(start)
  ; 1st dword is start x point on screen
  ; 2nd dword is loop  x ammount
.CODE
  ASM_ScanConvertEdges:
                 push ebp
                 mov ebp,esp
                 mov esi,dword ptr ss:[ebp+_PTR_Text]  ; Texture address
                 mov edi,dword ptr ss:[ebp+_PTR_Scrn]  ; Screen address + (starty*320)
                 mov ebx,dword ptr ss:[ebp+_PTR_Data]  ; Scan convert data and edges
                 mov ecx,dword ptr ss:[ebp+_PTR_Hght]  ; Height of poly
                                             ;ͻ
                                             ; st0 st1 st2 st3 st4 st5 st6 st7
                                             ;Ķ
                 fld  qword ptr ds:[ebx+ _j] ;  j                             
  Loop0001:                                  ;Ķ
                 fld  qword ptr ds:[ebx+_Uj] ; Uj   j                         
                 fmul st(0),st(1)            ; xx   j                         
                 fld  qword ptr ds:[ebx+_Uc] ; Uc  xx   j                     
                 faddp st(1),st(0)           ; xx   j                         
                 fstp qword ptr ds:[ebx+_xx] ;  j                             
                                             ;Ķ
                 fld  qword ptr ds:[ebx+_Vj] ; Vj   j                         
                 fmul st(0),st(1)            ; yy   j                         
                 fld  qword ptr ds:[ebx+_Vc] ; Vc  yy   j                     
                 faddp st(1),st(0)           ; yy   j                         
                 fstp qword ptr ds:[ebx+_yy] ;  j                             
                                             ;Ķ
                 fld  qword ptr ds:[ebx+_Zj] ; Zj   j                         
                 fmul st(0),st(1)            ; zz   j                         
                 fld  qword ptr ds:[ebx+_Zc] ; Zc  zz   j                     
                 faddp st(1),st(0)           ; zz   j                         
                 fstp qword ptr ds:[ebx+_zz] ;  j                             


                 pop ebp
                 ret
END
