#ifndef _STRUCTS_H_
#define _STRUCTS_H_
#include "..\compiler\compiler.h"

struct DATA_TMatrix
{
       FLOATINGPOINT M0,M1,M2,M3;
       FLOATINGPOINT M4,M5,M6,M7;
       FLOATINGPOINT M8,M9,MA,MB;
       FLOATINGPOINT MC,MD,ME,MF;
};

struct DATA_TRotAdd
{
       FLOATINGPOINT RotX,RotY,RotZ;
       FLOATINGPOINT AddX,AddY,AddZ;
       FLOATINGPOINT FixMul;
};

struct DATA_VertexL
{
       FLOATINGPOINT BegX,BegY,BegZ;
       FLOATINGPOINT EndX,EndY,EndZ;
};

struct DATA_ClpLine
{
       FLOATINGPOINT BegX,BegY,BegZ;
       FLOATINGPOINT EndX,EndY,EndZ;
};

struct DATA_VectorL
{
       FLOATINGPOINT BegX,BegY,BegZ;
       FLOATINGPOINT EndX,EndY,EndZ;
};

struct DATA__Camera
{
       FLOATINGPOINT BegX,BegY;
       FLOATINGPOINT MidX,MidY;
       FLOATINGPOINT EndX,EndY;
       FLOATINGPOINT FocalDist;
       FLOATINGPOINT Scale;
};

struct DATA_TxtScan
{
       FLOATINGPOINT   Ox,  Oy,  Oz;
       FLOATINGPOINT   Vx,  Vy,  Vz;
       FLOATINGPOINT   Ux,  Uy,  Uz;
       FLOATINGPOINT   Ui,  Uj,  Uc;
       FLOATINGPOINT   Vi,  Vj,  Vc;
       FLOATINGPOINT   Zi,  Zj,  Zc;
       FLOATINGPOINT   Ju,  Jv,  Jz;
       FLOATINGPOINT AdJu,AdJv,AdJz;
       FLOATINGPOINT    U,   V,   Z;
       FLOATINGPOINT    I,   J,CrFz;
       FLOATINGPOINT   Au,  Av,AdFz;
       FLOATINGPOINT   Cu,  Cv     ;
       FLOATINGPOINT FxIJ;
       DWORD         RenderToScreen;
};

#endif
//eof