;// O_TRANS.ASM - Translates Objects in 3D space by 80h byte rotation matrix
;//               Matrix is 16 * 8 byte floating-point numbers
// ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR
// ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR
// ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR

// Check data structures

// ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR
// ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR
// ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR
// ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR ERROR
.386
.387
  public         ASM_TransPoints
  public         ASM_BuildMatrix
  public         ASM_TransVector
.MODEL FLAT,C
.CODE
  ASM_TransPoints:
                 push ebp
                 mov ebp,esp
                 push ebx
                 push ecx
                 push edi
                 push esi
                 mov esi,ss:[ebp+08h]       ;  Source vector array (dword pointer)
                 mov edi,ss:[ebp+0Ch]       ;  Destination vector array (dword pointer)
                 mov ebx,ss:[ebp+10h]       ;  Rotation array (dword pointer)
                 mov ecx,ss:[ebp+14h]       ;  Count of array (dword signed)
  Jmp0000:                                  ;ͻ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                 fld qword ptr ds:[ebx+70h] ;  ME                            
                 fld qword ptr ds:[ebx+68h] ;  MD  ME                        
                 fld qword ptr ds:[ebx+60h] ;  MC  MD  ME                    
                 fld qword ptr ds:[esi+10h] ;  Z   MC  MD  ME                
                 fld qword ptr ds:[esi+08h] ;  Y   Z   MC  MD  ME            
                 fld qword ptr ds:[esi    ] ;  X   Y   Z   MC  MD  ME        
                 fld qword ptr ds:[ebx    ] ;  M0  X   Y   Z   MC  MD  ME    
                 fmul st(0),st(1)           ;X*M0  X   Y   Z   MC  MD  ME    
                 faddp st(4),st(0)          ;  X   Y   Z   X'  MD  ME        
                 fld qword ptr ds:[ebx+20h] ;  M4  X   Y   Z   X'  MD  ME    
                 fmul st(0),st(2)           ;Y*M4  X   Y   Z   X'  MD  ME    
                 faddp st(4),st(0)          ;  X   Y   Z   X'  MD  ME        
                 fld qword ptr ds:[ebx+40h] ;  M8  X   Y   Z   X'  MD  ME    
                 fmul st(0),st(3)           ;Z*M8  X   Y   Z   X'  MD  ME    
                 faddp st(4),st(0)          ;  X   Y   Z   X'  MD  ME        
                 fld qword ptr ds:[ebx+08h] ;  M1  X   Y   Z   X'  MD  ME    
                 fmul st(0),st(1)           ;X*M1  X   Y   Z   X'  MD  ME    
                 faddp st(5),st(0)          ;  X   Y   Z   X'  Y'  ME        
                 fld qword ptr ds:[ebx+28h] ;  M5  X   Y   Z   X'  Y'  ME    
                 fmul st(0),st(2)           ;Y*M5  X   Y   Z   X'  Y'  ME    
                 faddp st(5),st(0)          ;  X   Y   Z   X'  Y'  ME        
                 fld qword ptr ds:[ebx+48h] ;  M9  X   Y   Z   X'  Y'  ME    
                 fmul st(0),st(3)           ;Z*M9  X   Y   Z   X'  Y'  ME    
                 faddp st(5),st(0)          ;  X   Y   Z   X'  Y'  ME        
                 fld qword ptr ds:[ebx+10h] ;  M2  X   Y   Z   X'  Y'  ME    
                 fmul st(0),st(1)           ;X*M2  X   Y   Z   X'  Y'  ME    
                 faddp st(6),st(0)          ;  X   Y   Z   X'  Y'  Z'        
                 fld qword ptr ds:[ebx+30h] ;  M6  X   Y   Z   X'  Y'  Z'    
                 fmul st(0),st(2)           ;Y*M6  X   Y   Z   X'  Y'  Z'    
                 faddp st(6),st(0)          ;  X   Y   Z   X'  Y'  Z'        
                 fld qword ptr ds:[ebx+50h] ;  MA  X   Y   Z   X'  Y'  Z'    
                 fmul st(0),st(3)           ;Z*MA  X   Y   Z   X'  Y'  Z'    
                 faddp st(6),st(0)          ;  X   Y   Z   X'  Y'  Z'        
                 fstp st(0)                 ;  Y   Z   X'  Y'  Z'            
                 fstp st(0)                 ;  Z   X'  Y'  Z'                
                 fstp st(0)                 ;  X'  Y'  Z'                    
                 fstp qword ptr ds:[edi    ];  Y'  Z'                        
                 fstp qword ptr ds:[edi+08h];  Z'                            
                 fstp qword ptr ds:[edi+10h];ͼ
                 add esi,00000001Ch
                 add edi,00000001Ch
                 sub ecx,1
                 cmp ecx,0
                 jg  Jmp0000
                 pop esi
                 pop edi
                 pop ecx
                 pop ebx
                 mov esp,ebp
                 pop ebp
                 ret

  ASM_TransVector:
                 push ebp
                 mov ebp,esp
                 push ebx
                 push ecx
                 push edi
                 push esi
                 mov esi,ss:[ebp+08h]       ;  Source vector array (dword pointer)
                 mov edi,ss:[ebp+0Ch]       ;  Destination vector array (dword pointer)
                 mov ebx,ss:[ebp+10h]       ;  Rotation array (dword pointer)
                 mov ecx,2
  Jmp0000:                                  ;ͻ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                 fld qword ptr ds:[ebx+70h] ;  ME                            
                 fld qword ptr ds:[ebx+68h] ;  MD  ME                        
                 fld qword ptr ds:[ebx+60h] ;  MC  MD  ME                    
                 fld qword ptr ds:[esi+10h] ;  Z   MC  MD  ME                
                 fld qword ptr ds:[esi+08h] ;  Y   Z   MC  MD  ME            
                 fld qword ptr ds:[esi    ] ;  X   Y   Z   MC  MD  ME        
                 fld qword ptr ds:[ebx    ] ;  M0  X   Y   Z   MC  MD  ME    
                 fmul st(0),st(1)           ;X*M0  X   Y   Z   MC  MD  ME    
                 faddp st(4),st(0)          ;  X   Y   Z   X'  MD  ME        
                 fld qword ptr ds:[ebx+20h] ;  M4  X   Y   Z   X'  MD  ME    
                 fmul st(0),st(2)           ;Y*M4  X   Y   Z   X'  MD  ME    
                 faddp st(4),st(0)          ;  X   Y   Z   X'  MD  ME        
                 fld qword ptr ds:[ebx+40h] ;  M8  X   Y   Z   X'  MD  ME    
                 fmul st(0),st(3)           ;Z*M8  X   Y   Z   X'  MD  ME    
                 faddp st(4),st(0)          ;  X   Y   Z   X'  MD  ME        
                 fld qword ptr ds:[ebx+08h] ;  M1  X   Y   Z   X'  MD  ME    
                 fmul st(0),st(1)           ;X*M1  X   Y   Z   X'  MD  ME    
                 faddp st(5),st(0)          ;  X   Y   Z   X'  Y'  ME        
                 fld qword ptr ds:[ebx+28h] ;  M5  X   Y   Z   X'  Y'  ME    
                 fmul st(0),st(2)           ;Y*M5  X   Y   Z   X'  Y'  ME    
                 faddp st(5),st(0)          ;  X   Y   Z   X'  Y'  ME        
                 fld qword ptr ds:[ebx+48h] ;  M9  X   Y   Z   X'  Y'  ME    
                 fmul st(0),st(3)           ;Z*M9  X   Y   Z   X'  Y'  ME    
                 faddp st(5),st(0)          ;  X   Y   Z   X'  Y'  ME        
                 fld qword ptr ds:[ebx+10h] ;  M2  X   Y   Z   X'  Y'  ME    
                 fmul st(0),st(1)           ;X*M2  X   Y   Z   X'  Y'  ME    
                 faddp st(6),st(0)          ;  X   Y   Z   X'  Y'  Z'        
                 fld qword ptr ds:[ebx+30h] ;  M6  X   Y   Z   X'  Y'  Z'    
                 fmul st(0),st(2)           ;Y*M6  X   Y   Z   X'  Y'  Z'    
                 faddp st(6),st(0)          ;  X   Y   Z   X'  Y'  Z'        
                 fld qword ptr ds:[ebx+50h] ;  MA  X   Y   Z   X'  Y'  Z'    
                 fmul st(0),st(3)           ;Z*MA  X   Y   Z   X'  Y'  Z'    
                 faddp st(6),st(0)          ;  X   Y   Z   X'  Y'  Z'        
                 fstp st(0)                 ;  Y   Z   X'  Y'  Z'            
                 fstp st(0)                 ;  Z   X'  Y'  Z'                
                 fstp st(0)                 ;  X'  Y'  Z'                    
                 fstp qword ptr ds:[edi    ];  Y'  Z'                        
                 fstp qword ptr ds:[edi+08h];  Z'                            
                 fstp qword ptr ds:[edi+10h];ͼ
                 add esi,00000001Ch
                 add edi,00000001Ch
                 sub ecx,1
                 cmp ecx,0
                 jg  Jmp0000
                 pop esi
                 pop edi
                 pop ecx
                 pop ebx
                 mov esp,ebp
                 pop ebp
                 ret

  ASM_BuildMatrix:
                 push ebp
                 mov ebp,esp
                 push ebx
                 push edi
                 push esi
                 mov esi,ss:[ebp+08h]       ;  Source XYZ rotation and XYZ add values
                 mov edi,ss:[ebp+0Ch]       ;  Destination matrix
                 mov ebx,ss:[ebp+10h]       ;  Fix angle number (pi/180)
                                            ;ͻ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                 fld qword ptr ds:[esi+10h] ;  Z                             
                 fld qword ptr ds:[esi+08h] ;  Y   Z                         
                 fld qword ptr ds:[esi    ] ;  X   Y   Z                     
                 fld qword ptr ds:[ebx    ] ; Fix  X   Y   Z                 
                 fmul  st(1),st(0)          ; Fix  X   Y   Z                 
                 fmul  st(2),st(0)          ; Fix  X   Y   Z                 
                 fmulp st(3),st(0)          ;  X   Y   Z                     
                 fld st(0)                  ;  X   X   Y   Z                 
                 fsin                       ;SinX  X   Y   Z                 
                 fxch st(1)                 ;  X SinX  Y   Z                 
                 fcos                       ;CosXSinX  Y   Z                 
                 fxch st(2)                 ;  Y SinXCosX  Z                 
                 fld st(0)                  ;  Y   Y SinXCosX  Z             
                 fsin                       ;SinY  Y SinXCosX  Z             
                 fxch st(1)                 ;  Y SinYSinXCosX  Z             
                 fcos                       ;CosYSinYSinXCosX  Z             
                 fxch st(4)                 ;  Z SinYSinXCosXCosY            
                 fld st(0)                  ;  Z   Z SinYSinXCosXCosY        
                 fsin                       ;SinZ  Z SinYSinXCosXCosY        
                 fxch st(1)                 ;  Z SinZSinYSinXCosXCosY        
                 fcos                       ;CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(1)                  ;SinZCosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(4)           ;  M0CosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(3)           ;  M0CosZSinZSinYSinXCosXCosY    
                 fld st(6)                  ;CosY  M0CosZSinZSinYSinXCosXCosY
                 fmul st(0),st(2)           ;  M0  M0CosZSinZSinYSinXCosXCosY
                 faddp st(1),st(0)          ;  M0CosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi    ];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(0)                  ;CosZCosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(4)           ;  M1CosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(3)           ;  M1CosZSinZSinYSinXCosXCosY    
                 fld st(6)                  ;CosY  M1CosZSinZSinYSinXCosXCosY
                 fmul st(0),st(3)           ;  M1  M1CosZSinZSinYSinXCosXCosY
                 fsubp st(1),st(0)          ;  M1CosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+08h];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(2)                  ;SinYCosZSinZSinYSinXCosXCosY    
                 fchs                       ;  M2CosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(5)           ;  M2CosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+10h];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(4)                  ;CosXCosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(2)           ;  M4CosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+20h];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(4)                  ;CosXCosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(1)           ;  M5CosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+28h];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(3)                  ;SinXCosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+30h];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(0)                  ;CosZCosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(3)           ;  M8CosZSinZSinYSinXCosXCosY    
                 fld st(2)                  ;SinZ  M8CosZSinZSinYSinXCosXCosY
                 fmul st(0),st(5)           ;  M8  M8CosZSinZSinYSinXCosXCosY
                 fmul st(0),st(7)           ;  M8  M8CosZSinZSinYSinXCosXCosY
                 fsubp st(1),st(0)          ;  M8CosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+40h];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(5)                  ;CosYCosZSinZSinYSinXCosXCosY    
                 fchs                       ;  M9CosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(4)           ;  M9CosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(1)           ;  M9CosZSinZSinYSinXCosXCosY    
                 fld  st(3)                 ;SinY  M9CosZSinZSinYSinXCosXCosY
                 fmul st(0),st(3)           ;  M9  M9CosZSinZSinYSinXCosXCosY
                 fsubp st(1),st(0)          ;  M9CosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+48h];CosZSinZSinYSinXCosXCosY        
                                            ;Ķ
                                            ; st0 st1 st2 st3 st4 st5 st6 st7
                                            ;Ķ
                                            ;CosZSinZSinYSinXCosXCosY        
                 fld st(5)                  ;CosYCosZSinZSinYSinXCosXCosY    
                 fmul st(0),st(5)           ;  MACosZSinZSinYSinXCosXCosY    
                 fstp qword ptr ds:[edi+50h];CosZSinZSinYSinXCosXCosY        
                 emms                       ;                                
                 fldz                       ;  0                             
                 fst  qword ptr ds:[edi+18h];  0                             
                 fst  qword ptr ds:[edi+38h];  0                             
                 fst  qword ptr ds:[edi+58h];  0                             
                 fstp qword ptr ds:[edi+78h];                                
                 fld  qword ptr ds:[esi+28h];AddZ                            
                 fld  qword ptr ds:[esi+20h];AddYAddZ                        
                 fld  qword ptr ds:[esi+18h];AddXAddYAddZ                    
                 fstp qword ptr ds:[edi+60h];AddYAddZ                        
                 fstp qword ptr ds:[edi+68h];AddZ                            
                 fstp qword ptr ds:[edi+70h];ͼ
                 pop esi
                 pop edi
                 pop ebx
                 mov esp,ebp
                 pop ebp
                 ret
END
