#include "clip2d.h"
#include <math.h>

DWORD CPP_XClipVisLine(DATA_ClpLine *SrcV,
                       DATA_ClpLine *DstV,
                       DATA__Camera *Camm,
                       DWORD         NumV
                      )
{
      DWORD CurV;
      DWORD RetV;
      FLOATINGPOINT SXs,SYs,SZs,EXs,EYs,EZs;
      FLOATINGPOINT SXd,SYd,SZd,EXd,EYd,EZd;
      FLOATINGPOINT DelX,DelY,DelZ;
      FLOATINGPOINT SaveSX,SaveSY,SaveSZ;
      FLOATINGPOINT SaveBX,SaveBY,SaveBZ;
      DWORD         NumSXHit,NumBXHit;
      RetV=0;
      NumSXHit=0;
      NumBXHit=0;
      for (CurV=0;CurV<NumV;CurV++)
      {   SXs=SrcV[CurV].BegX;
          SYs=SrcV[CurV].BegY;
          SZs=SrcV[CurV].BegZ;
          EXs=SrcV[CurV].EndX;
          EYs=SrcV[CurV].EndY;
          EZs=SrcV[CurV].EndZ;
          DelX=EXs-SXs;
          DelY=EYs-SYs;
          DelZ=EZs-SZs;
          if (DelX==0)DelX=1;
          if       (  ((SXs<Camm[0].BegX)&&(EXs<Camm[0].BegX))
                    ||((SXs>Camm[0].EndX)&&(EXs>Camm[0].EndX))  )
          {
          } else
          {
             if       (SXs<Camm[0].BegX)
             {
                SXd=Camm[0].BegX;
                SYd=SYs+((Camm[0].BegX-SXs)*(DelY/ DelX));
                SZd=SZs+((Camm[0].BegX-SXs)*(DelZ/ DelX));
                switch (NumSXHit)
                {
                       case 0:SaveSX=SXd;
                              SaveSY=SYd;
                              SaveSZ=SZd;
                       break;
                       case 1:DstV[RetV].BegX=SaveSX;
                              DstV[RetV].BegY=SaveSY;
                              DstV[RetV].BegZ=SaveSZ;
                              DstV[RetV].EndX=SXd;
                              DstV[RetV].EndY=SYd;
                              DstV[RetV].EndZ=SZd;
                              RetV++;
                       break;
                       //default:
                }
                NumSXHit++;
             }else if (SXs>Camm[0].EndX)
             {
                SXd=Camm[0].EndX;
                SYd=SYs+((SXs-Camm[0].EndX)*(DelY/-DelX));
                SZd=SZs+((SXs-Camm[0].EndX)*(DelZ/-DelX));
                switch (NumBXHit)
                {
                       case 0:SaveBX=SXd;
                              SaveBY=SYd;
                              SaveBZ=SZd;
                       break;
                       case 1:DstV[RetV].BegX=SaveBX;
                              DstV[RetV].BegY=SaveBY;
                              DstV[RetV].BegZ=SaveBZ;
                              DstV[RetV].EndX=SXd;
                              DstV[RetV].EndY=SYd;
                              DstV[RetV].EndZ=SZd;
                              RetV++;
                       break;
                       //default:
                }
                NumBXHit++;
             }else
             {
                SXd=SXs;
                SYd=SYs;
                SZd=SZs;
             }
             if       (EXs<Camm[0].BegX)
             {
                EXd=Camm[0].BegX;
                EYd=EYs+((Camm[0].BegX-EXs)*(DelY/ DelX));
                EZd=EZs+((Camm[0].BegX-EXs)*(DelZ/ DelX));
                switch (NumSXHit)
                {
                       case 0:SaveSX=EXd;
                              SaveSY=EYd;
                              SaveSZ=EZd;
                       break;
                       case 1:DstV[RetV].BegX=SaveSX;
                              DstV[RetV].BegY=SaveSY;
                              DstV[RetV].BegZ=SaveSZ;
                              DstV[RetV].EndX=EXd;
                              DstV[RetV].EndY=EYd;
                              DstV[RetV].EndZ=EZd;
                              RetV++;
                       break;
                       //default:
                }
                NumSXHit++;
             }else if (EXs>Camm[0].EndX)
             {
                EXd=Camm[0].EndX;
                EYd=EYs+((EXs-Camm[0].EndX)*(DelY/-DelX));
                EZd=EZs+((EXs-Camm[0].EndX)*(DelZ/-DelX));
                switch (NumBXHit)
                {
                       case 0:SaveBX=EXd;
                              SaveBY=EYd;
                              SaveBZ=EZd;
                       break;
                       case 1:DstV[RetV].BegX=SaveBX;
                              DstV[RetV].BegY=SaveBY;
                              DstV[RetV].BegZ=SaveBZ;
                              DstV[RetV].EndX=EXd;
                              DstV[RetV].EndY=EYd;
                              DstV[RetV].EndZ=EZd;
                              RetV++;
                       break;
                       //default:
                }
                NumBXHit++;
             }else
             {
                EXd=EXs;
                EYd=EYs;
                EZd=EZs;
             }
             DstV[RetV].BegX=SXd;
             DstV[RetV].BegY=SYd;
             DstV[RetV].BegZ=SZd;
             DstV[RetV].EndX=EXd;
             DstV[RetV].EndY=EYd;
             DstV[RetV].EndZ=EZd;
             RetV++;
          }
      }
      return(RetV);
}

DWORD CPP_YClipVisLine(DATA_ClpLine *SrcV,
                       DATA_ClpLine *DstV,
                       DATA__Camera *Camm,
                       DWORD         NumV
                      )
{
      DWORD CurV;
      DWORD RetV;
      DWORD NumXHit;
      FLOATINGPOINT SXs,SYs,SZs,EXs,EYs,EZs;
      FLOATINGPOINT SXd,SYd,SZd,EXd,EYd,EZd;
      FLOATINGPOINT DelX,DelY,DelZ;
      RetV=0;
      NumXHit=0;
      for (CurV=0;CurV<NumV;CurV++)
      {   SXd=SXs=SrcV[CurV].BegX;
          SYd=SYs=SrcV[CurV].BegY;
          SZd=SZs=SrcV[CurV].BegZ;
          EXd=EXs=SrcV[CurV].EndX;
          EYd=EYs=SrcV[CurV].EndY;
          EZd=EZs=SrcV[CurV].EndZ;
          DelX=EXs-SXs;
          DelY=EYs-SYs;
          DelZ=EZs-SZs;
          if (DelY==0)DelY=1;
          if       (  ((SYs<Camm[0].BegY)&&(EYs<Camm[0].BegY))
                    ||((SYs>Camm[0].EndY)&&(EYs>Camm[0].EndY))  )
          {
          } else
          {
             if       (SYs<Camm[0].BegY)      // if starty < cam beg y
             {
                SXd=SXs+((Camm[0].BegY-SYs)*(DelX/ DelY));
                SYd=Camm[0].BegY;
                SZd=SZs+((Camm[0].BegY-SYs)*(DelZ/ DelY));
             }else if (SYs>Camm[0].EndY)      // if starty > cam end y
             {
                SXd=SXs+((SYs-Camm[0].EndY)*(DelX/-DelY));
                SYd=Camm[0].EndY;
                SZd=SZs+((SYs-Camm[0].EndY)*(DelZ/-DelY));
             } else                            // if starty within camera
             {  SXd=SXs;
                SYd=SYs;
                SZd=SZs;
             }
             if        (EYs<Camm[0].BegY)      // if endy < cam beg y
             {
                EXd=EXs+((Camm[0].BegY-EYs)*(DelX/ DelY));
                EYd=Camm[0].BegY;
                EZd=EZs+((Camm[0].BegY-EYs)*(DelZ/ DelY));
             } else if (EYs>Camm[0].EndY)      // if endy > cam end y
             {
                EXd=EXs+((EYs-Camm[0].EndY)*(DelX/-DelY));
                EYd=Camm[0].EndY;
                EZd=EZs+((EYs-Camm[0].EndY)*(DelZ/-DelY));
             } else                            // if endy within camera
             {  EXd=EXs;
                EYd=EYs;
                EZd=EZs;
             }
             DstV[RetV].BegX=SXd;
             DstV[RetV].BegY=SYd;
             DstV[RetV].BegZ=SZd;
             DstV[RetV].EndX=EXd;
             DstV[RetV].EndY=EYd;
             DstV[RetV].EndZ=EZd;
             RetV++;
          }
      }
      return(RetV);
}
