#ifndef _COMPILER_H_
        #define _COMPILER_H_
        #define     BYTE                   unsigned char
        #define     CHAR                   char
        #define     WORD                   unsigned short int
        #define     SWORD                  short int
        #define     DWORD                  unsigned int
        #define     SDWORD                 int
        #define     FLOATINGPOINT          double

        void CopyByteDATA(void *,void *,DWORD);
        void FillByteDATA(void *,BYTE,DWORD);
        void FillQWordDATA(void *,DWORD,DWORD,DWORD);

        #if      defined(__WATCOMC__)



              #pragma aux CopyByteDATA =                                  \
                          "cld                                           "\
                          "rep movsb                                     "\
                          parm [esi] [edi] [ecx]                          \
                          modify [esi edi ecx eax];

              #pragma aux FillByteDATA =                                  \
                          "cld                                           "\
                          "rep stosb                                     "\
                          parm [edi] [al] [ecx]                           \
                          modify [edi ecx eax];

              #pragma aux FillQWordDATA =                                 \
                          "FillLoop:                                     "\
                          "mov ds:[edi+4],eax                            "\
                          "mov ds:[edi  ],ebx                            "\
                          "add edi,8                                     "\
                          "sub ecx,1                                     "\
                          "cmp ecx,0                                     "\
                          "jg FillLoop                                   "\
                          parm [edi] [eax] [ebx] [ecx]                           \
                          modify [edi ecx eax ebx];

        #endif
#endif
//eof