#ifndef _ENGINE_H_
#define _ENGINE_H_
#include <windows.h>
#include <windowsx.h>
#include "../../compiler/compiler.h"
#include "../../trans/trans.h"
#include "../../clipping/clip2d.h"
#include "../../clipping/clip3d.h"

void        Engine_UpdateDisplay(void);
BOOL        Engine_Init(void);
void        Engine_Destroy(void);
struct ColorVal
{
       union
       {
            struct
            {
                 WORD B:5;
                 WORD G:6;
                 WORD R:5;
            }    Bits;
            WORD Color16;
       };
};

ColorVal               *VirtScr;         // Off-screen buffer
#define                 VirtualScrSize   64000*2


#endif
//eof